#include <avr/sleep.h>

#define SLEEP_PIN 3
#define WAKEUP_PIN 2

volatile byte flag = 0;

void setup() {
  pinMode(SLEEP_PIN, INPUT);
  pinMode(WAKEUP_PIN, INPUT);
  pinMode(LED_BUILTIN, OUTPUT);
  digitalWrite(LED_BUILTIN, LOW);
  attachInterrupt(digitalPinToInterrupt(SLEEP_PIN), sleepCallback, RISING);
}

void loop() {
  if (flag) {
    sleep();
  }
  delay(10);
}

void sleepCallback() {
  flag = 1;
}
  
void wakeupCallback() {
  flag = 0;
}

void sleep() {
  sleep_enable();
  set_sleep_mode(SLEEP_MODE_PWR_DOWN);
  detachInterrupt(digitalPinToInterrupt(SLEEP_PIN));
  attachInterrupt(digitalPinToInterrupt(WAKEUP_PIN), wakeupCallback, RISING);
  delay(200);
  sleep_cpu();

  // codice eseguito dopo il risveglio
  detachInterrupt(digitalPinToInterrupt(WAKEUP_PIN));
  attachInterrupt(digitalPinToInterrupt(SLEEP_PIN), sleepCallback, RISING);
  sleep_disable();
}